      SUBROUTINE F500
      DIMENSION RM(3,3),V(3,4)
      DIMENSION A(9),AA(3,3),AAREV(3,3),AAWRK(3,3),AID(3,3),AIN(140)
      DIMENSION ATOMS(4,500),BB(3,3),CD(8,10),   CONT(5),D(3,130)
      DIMENSION DA(3,3),DP(2,130),EV(3,100),FS(3,3,48),KD(5,10),ORGN(3)
      DIMENSION P(3,100),PA(3,3,100),PAC(3,5),PAT(3,3),Q(3,3),REFV(3,3)
      DIMENSION RES(4),RMS(5),SYMB(3,3),       TS(3,48)
      DIMENSION VT(3,4),V1(4),V2(3),V3(3),V4(3),V5(3),V6(3),WRKV(3,3)
      DIMENSION XLNG(3),XO(3),XT(3)
      DIMENSION B(3,3),VV(3,3),SUM(3),INDEX(3),XA(3)
      COMMON NG,A,AA,AAREV,AAWRK,AID,AIN,ATOMS,BB,BRDR,CD,   CONT,D
      COMMON DA,DP,DISP,EDGE,EV,FORE,FS,IN,ITILT,KD,LATM,LTNO,NATOM,NCD
      COMMON NJ,NJ2,NOUT,NSR,NSYM,ORGN,P,PA,PAC,PAT,Q,REFV,RES,RMS,SCAL1
      COMMON SCAL2,SCL,SYMB,TAPER,THETA,       TS,VIEW,VT,V1,V2
      COMMON V3,V4,V5,V6,WRKV,XLNG,XO,XT
      COMMON SHIFTX,SHIFTY
      CHARACTER*6 CHEM(100), TITLE(18)*4, TITLE2(18)*4
      COMMON /LABEL/ CHEM, TITLE, TITLE2
      NG=0
      IF(NJ2-11)  500,600,610
  500 IF(NJ2-1)  610,501,510
  501 T1=AIN(1)
      CALL ATOM(T1,ORGN)
      IF(NG)502,504,502
  502 CALL ERPNT(T1,501)
      stop
  504 DO 506 K=1,4
      T1=AIN(K+1)
      CALL ATOM(T1,V(1,K))
      IF(NG)502,506,502
  506 CONTINUE
      DO 507 J=1,3
      V1(J)=V(J,2)-V(J,1)
  507 V2(J)=V(J,4)-V(J,3)
      IND=-1
      IF(AIN(7))509,509,508
  508 IND=-2
  509 CALL AXES(V1,V2,REFV,IND)
      GO TO 562
  510 IF(NJ2-4)  515,511,514
C  ***** SHIFT ORIGIN FOR PROJECTION AXIS(IN CENTIMETERS) *****
  511 DO 513 J=1,3
      DO 512 K=1,3
  512 ORGN(J)=ORGN(J)+REFV(J,K)*AIN(K)/SCAL1
  513 XO(J)=XO(J)+AIN(J)
      GO TO 570
  514 IF (NJ2-5) 610,505,599
C  ***** INSTRUCTION 505 *****  FIND ORIENTATION OF LEAST SQUARES PLANE
  505 NJ2=2
C ***** INITIALISE ARRAYS
      DO 517 J=1,3
      SUM(J)=0.0
      DO 519 I=1,3
  519 B(I,J)=0.0
  517 CONTINUE
C ***** CONVERT ATOM COORDINATES TO ORTHONORMAL REFERENCE SYSTEM
      DO 520 I=1,LATM
      DO 534 L=1,3
  534 XA(L)=AAREV(1,L)*ATOMS(2,I) + AAREV(2,L)*ATOMS(3,I)
     * + AAREV(3,L)*ATOMS(4,I)
C ***** COMPUTE CENTROID AND SET UP MATRIX FOR PLANE FITTING CALCULATION
      DO 521 J=1,3
      SUM(J)=SUM(J)+XA(J)
      DO 523 K=1,3
  523 B(J,K)=B(J,K)+XA(J)*XA(K)
  521 CONTINUE
  520 CONTINUE
C ***** SUBTRACT COORDINATES OF CENTROID
      DO 524 J=1,3
      DO 526 K=1,3
  526 B(J,K)=B(J,K)-SUM(J)*SUM(K)/LATM
  524 CONTINUE
C ***** CALCULATE EIGENVECTORS AND EIGENVALUES OF MATRIX B(J,K)
      CALL EIGEN2(B,VV,INDEX)
      WRITE (NOUT,530) ((VV(J,K), K=1,3), J=1,3)
  530 FORMAT(//11X,'MODAL MATRIX:',3(/11X,3F10.5))
      WRITE (NOUT,536) ((B(J,K), K=1,3), J=1,3)
  536 FORMAT(//11X,'MATRIX B(J,K) DIAGONALISED:',3(/11X,3D15.4))
      WRITE (NOUT, 527) INDEX
  527 FORMAT(//11X,'ORDER OF MAGNITUDE OF THE EIGENVALUES:',3I8)
      ALPH=ATAN2(VV(1,2), -VV(1,3))*57.2957795
      BETA=ATAN2(SQRT(VV(2,1)**2+VV(3,1)**2), VV(1,1))*57.2957795
      GAM=ATAN2(VV(2,1), VV(3,1))*57.2957795
      WRITE (NOUT,533) -GAM,-BETA,-ALPH
  533 FORMAT(/11X,'ROTATION ANGLES FOR THE LEAST-SQUARES PLANE ','CORRES
     &POND TO:',//17X,'502',8X,'1',F9.1,8X,'2',F9.1,8X,'1',F9.1)
      DO 531 I=1,140
  531 AIN(I)=0.0
      AIN(1)=1.
      AIN(3)=2.
      AIN(5)=1.
      AIN(2)=-GAM
      AIN(4)=-BETA
      AIN(6)=-ALPH
C  ***** FORM ROTATION MATRIX *****
  515 DO 552 L=1,139,2
      I=AIN(L)
      IF(I) 532,552,516
  516 X=AIN(L+1)*1.7453293E-2
      T1=COS(X)
      T2=SIN(X)
      I3=MOD(I+2,3)+1
      I1=MOD(I3,3)+1
      I2=MOD(I1,3)+1
      RM(I1,I1)=T1
      RM(I1,I2)=T2
      RM(I1,I3)=0.0
      RM(I2,I1)=-T2
      RM(I2,I2)=T1
      RM(I2,I3)=0.0
      RM(I3,I1)=0.0
      RM(I3,I2)=0.0
      RM(I3,I3)=1.0
      CALL MM(REFV,RM,V)
      IF(NJ2-3)518,525,599
  518 DO 522 J=1,9
  522 REFV(J,1)=V(J,1)
      GO TO 552
  525 DO 528 J=1,9
  528 WRKV(J,1)=V(J,1)
      GO TO 552
  532 IF(NJ2-3)535,552,599
  535 I=MOD(-I,3)
      DO 542 J=1,I
      DO 542 K=1,3
      T1=REFV(K,3)
      REFV(K,3)=REFV(K,2)
      REFV(K,2)=REFV(K,1)
  542 REFV(K,1)=T1
  552 CONTINUE
      IF(NJ2-3)562,582,599
  562 CALL MM(AA,REFV,AAREV)
  570 DO 572 J=1,9
      WRKV(J,1)=REFV(J,1)
  572 AAWRK(J,1)=AAREV(J,1)
      GO TO 599
  582 CALL MM(AA,WRKV,AAWRK)
  599 CONTINUE
C     ** ELIMINATE ALL PREVIOUSLY STORED OVERLAP INFORMATION *****
C  *****(ALL INSTRUCTIONS FROM 501 THROUGH 510 DO THIS) *****
      CALL LAP500(0)
      GO TO 610
C  ***** STORE NEW OVERLAP INFORMATION (INSTRUCTION 511) *****
  600 CALL LAP500(1)
  610 RETURN
      END
