      SUBROUTINE SEARC
      DIMENSION NW(6),DX(3),S(2,200),U(3),V(3),W(2,4),WW(2,3),X(4),Y(3)
      DIMENSION    DZ(3),VAUTR(3),ALPHA(2),PROJ(2)
      DIMENSION Z(3)
      DIMENSION A(9),AA(3,3),AAREV(3,3),AAWRK(3,3),AID(3,3),AIN(140)
      DIMENSION ATOMS(4,500),BB(3,3),CD(8,10),   CONT(5),D(3,130)
      DIMENSION DA(3,3),DP(2,130),EV(3,100),FS(3,3,48),KD(5,10),ORGN(3)
      DIMENSION P(3,100),PA(3,3,100),PAC(3,5),PAT(3,3),Q(3,3),REFV(3,3)
      DIMENSION RES(4),RMS(5),SYMB(3,3),       TS(3,48)
      DIMENSION VT(3,4),V1(4),V2(3),V3(3),V4(3),V5(3),V6(3),WRKV(3,3)
      DIMENSION XLNG(3),XO(3),XT(3)
      COMMON NG,A,AA,AAREV,AAWRK,AID,AIN,ATOMS,BB,BRDR,CD,   CONT,D
      COMMON DA,DP,DISP,EDGE,EV,FORE,FS,IN,ITILT,KD,LATM,LTNO,NATOM,NCD
      COMMON NJ,NJ2,NOUT,NSR,NSYM,ORGN,P,PA,PAC,PAT,Q,REFV,RES,RMS,SCAL1
      COMMON SCAL2,SCL,SYMB,TAPER,THETA,       TS,VIEW,VT,V1,V2
      COMMON V3,V4,V5,V6,WRKV,XLNG,XO,XT
      COMMON SHIFTX,SHIFTY
      CHARACTER*6 CHEM(100), TITLE(18)*4, TITLE2(18)*4
      COMMON /LABEL/ CHEM, TITLE, TITLE2
      EQUIVALENCE (NW(1),LL),(NW(2),LU),(NW(3),ML)
      EQUIVALENCE (NW(4),MU),(NW(5),NL),(NW(6),NU)
C     ***** OBTAIN PROBLEM PARAMETERS *****
      NNJ2=0
      IF(NJ2.EQ.8) THEN
      NJ2=1
      NNJ2=1
      ENDIF
      WRITE (NOUT,20)
   20 FORMAT(1H0,9X,82H        FROM ATOMS    TO ATOMS     WITH RADIUS OR
     &, IF A BOX, WITH SEMIDIMENSIONS  /11X,46HCODE   (MIN  MAX)   (MIN 
     & MAX)                ,7X,1HA,8X,1HB,8X,1HC)
      IF(AIN(1)-10000.)100,100,101
  100 ITOM1=AIN(1)
      SYITOM=55501.
      GO TO 103
  101 ITOM1=AIN(1)/100000.
      SYITOM=AMOD(AIN(1),100000.)
  102 IF(ABS(AIN(2))-10000.)103,103,104
  103 ITOM2=ABS(AIN(2))
      SYITO2=SYITOM
      GO TO 105
  104 ITOM2=ABS(AIN(2))/100000.
      SYITO2=AMOD(ABS(AIN(2)),100000.)
  105 ITAR1=AIN(3)
      IF(ITAR1)108,108,110
  108 ITAR1=1
  110 ITAR2=AIN(4)
      DMAX=AIN(5)
      IF(DMAX)115,115,120
  115 DMAX=4.
      AIN(5)=DMAX
  120 DMX=DMAX*DMAX
      TEM=.01
      KFUN=NJ*100+MOD(NJ2,10)
      K=NJ*100+NJ2
      I0=SYITOM
      I02=SYITO2
      LATOM=LATM
  121 FORMAT(1H0,10X,2I3,I5,I4,I5,2I4,18X,3F9.3/1H )
      WRITE (NOUT,121)K,ITOM1,I0,ITOM2,I02,
     1ITAR1,ITAR2,(AIN(J),J=5,7)
  124 FORMAT(1H ,15X,2I5,I8,I5,2F9.3)
      IF(NCD)130,130,125
  125 WRITE (NOUT,124) ((KD(J,I),J=1,4),(CD(J,I),J=1,2) ,I=1,
     1NCD)
  130 DO 135 J=1,4
      W(1,J)=99.
  135 W(2,J)=-99.
      DO 155 I=ITAR1,ITAR2
      T1=FLOAT(I)*100000.
      CALL ATOM(T1,X)
      IF(NG)140,145,140
  140 CALL ERPNT(T1,KFUN)
      GO TO 600
  145 X(4)=X(1)-X(2)
      DO 155 J=1,4
      TEM=X(J)
      IF(W(2,J)-TEM)148,150,150
  148 W(2,J)=TEM
  150 IF(TEM-W(1,J))152,155,155
  152 W(1,J)=TEM
  155 CONTINUE
      KFUN2=MOD(KFUN,10)
      GO TO (165,165,160,156,165,165),KFUN2
C     ***** FIND PARALLELEPIPED WHICH ENCLOSES TRICLINIC BOX *****
  156 DO 158 J=1,3
  158 DX(J)=AIN(J+4)
      GO TO 170
C     ***** FIND PARALLELEPIPED WHICH ENCLOSES RECTANGULAR BOX *****
  160 DO 162 J=1,3
      DX(J)=0.
      DO 162 I=1,3
  162 DX(J)=DX(J)+ABS(REFV(J,I)*AIN(I+4))
      GO TO 170
C     ***** FIND PARALLELEPIPED WHICH ENCLOSES DMAX SPHERE *****
  165 T1=1.-A(4)*A(4)-A(5)*A(5)-A(6)*A(6)+2.*A(4)*A(5)*A(6)
      DO 168 J=1,3
  168 DX(J)=SQRT((1.-A(J+3)**2)/T1)*DMAX/A(J)
C     ***** START SEARCH AROUND REFERENCE ATOMS *****
  170 LIST=0
      LAST=0
      M1=ITOM1
      N1=ITOM2
      IF(KFUN2-5)186,172,172
C     ***** CONVOLUTE AND REITERATIVE CONVOLUTE INSTRUCTIONS *****
  172 IF(LATM)174,174,176
C     ***** FAULT, NO ENTRIES IN ATOMS LIST *****
  174 NG=12
      CALL ERPNT(0.,KFUN)
      GO TO 600
C     ***** CHECK FOR REFERENCE ATOMS IN ATOMS LIST *****
  176 IF(LATM-LAST)600,600,177
  177 LIST=LAST
      LAST=LATM
  178 LIST=LIST+1
      IF(LAST-LIST)505,180,180
  180 T1=ATOMS(1,LIST)
      ITOM=T1/100000.
      IF(ITOM-ITOM1)178,184,182
  182 IF(ITOM2-ITOM)178,184,184
  184 SYITOM=AMOD(T1,100000.)
      SYITO2=SYITOM
      M1=ITOM
      N1=ITOM
C     ***** SET INITIAL RUN PARAMETERS *****
  186 M2=AMOD(SYITOM,100.)
      M5=AMOD(SYITOM/100.,1000.)
      M3=M5/100
      M4=MOD(M5/10,10)
      M5=MOD(M5,10)
C     ***** SET TERMINAL RUN PARAMETERS *****
      N2=AMOD(SYITO2,100.)
      N5=AMOD(SYITO2/100.,1000.)
      N3=N5/100
      N4=MOD(N5/10,10)
      N5=MOD(N5,10)
C     ***** START SEARCH AROUND REFERENCE ATOMS *****
      DO 500 L5=M5,N5
      DO 500 L4=M4,N4
      DO 500 L3=M3,N3
      DO 500 L2=M2,N2
      DO 500 ITOM=M1,N1
      T1=FLOAT(ITOM)*100000.+FLOAT(L3*10000+L4*1000+L5*100+L2)
      CALL ATOM(T1,Y)
      IF(NG)188,190,188
  188 CALL ERPNT(T1,KFUN)
      GO TO 500
C     ***** K=SYMMETRY EQUIVALENT POSITION *****
  190 NUM=0
      DO 400 K=1,NSYM
C     ***** SUBTRACT SYMMETRY TRANSLATION FROM REFERENCE ATOM *****
      DO 192 J=1,3
  192 U(J)=Y(J)-TS(J,K)
C     ***** DETERMINE LIMITING CELLS TO BE SEARCHED *****
C     ***** FIRST,MOVE THE BOX THROUGH THE SYMMETRY OPERATION *****
      DO 200 J=1,3
      DO 200 L=1,2
      WW(L,J)=0.0
      DO 200 I=1,3
      TEM=FS(I,J,K)
      IF(TEM)194,200,196
  194 N=MOD(L,2)+1
      GO TO 198
  196 N=L
  198 WW(L,J)=WW(L,J)+W(N,I)*TEM
  200 CONTINUE
C     ***** CHECK FOR MIXED INDEX TRANSFORMATION *****
      DO 215 J=1,2
      TEM=FS(1,J,K)
      IF(TEM+FS(2,J,K))215,201,215
  201 IF(TEM)203,215,207
  203 WW(1,J)=W(2,4)*TEM
      WW(2,J)=W(1,4)*TEM
      GO TO 215
  207 WW(1,J)=W(1,4)*TEM
      WW(2,J)=W(2,4)*TEM
  215 CONTINUE
C     ***** MOVE 4 CELLS AWAY THEN MOVE BACK UNTIL PARALLELEPIPED AROUND
C         REF ATOM AND BOX AROUND TRANSFORMED ASYM UNIT INTERSECT *****
      N=0
      DO 235 J=1,3
      DO 225 I=1,2
      N=N+1
      TT=(U(J)-WW(I,J))*FLOAT(I*2-3)-DX(J)
      TEM=5.0
  221 TEM=TEM-1.0
      IF(TEM+TT)225,225,221
  225 NW(N)=TEM*FLOAT(I*2-3)+5.
C     ***** IF NO POSSIBILITY OF A HIT, GO TO NEXT SYMMETRY OPER *****
      IF(NW(N)-NW(N-1))400,235,235
  235 CONTINUE
      LL=NW(1)
      LU=NW(2)
      ML=NW(3)
      MU=NW(4)
      NL=NW(5)
      NU=NW(6)
C     ***** L CELL TRANSLATIONS IN X *****
      DO 395 L=LL,LU
      V(1)=U(1)+FLOAT(L-5)
C     ***** M CELL TRANSLATIONS IN Y *****
      DO 395 M=ML,MU
      V(2)=U(2)+FLOAT(M-5)
C     ***** N CELL TRANSLATIONS IN Z *****
      DO 395 NN=NL,NU
      V(3)=U(3)+FLOAT(NN-5)
C     ***** I = TARGET ATOM *****
      DO 395 I=ITAR1,ITAR2
      DO 250 J=1,3
      TEM=0.0
      DO 245 II=1,3
  245 TEM=TEM+FS(II,J,K)*P(II,I)
C     ***** SEE IF WITHIN PARALLELEPIPED*****
      TEM=TEM-V(J)
      IF(DX(J)-ABS(TEM))395,250,250
  250 X(J)=TEM
      GO TO (255,255,252,277,255,255),KFUN2
C     ***** SEE IF WITHIN MODEL BOX *****
  252 CALL VM(X,AAREV,V1(2))
      DO 253 J=2,4
      IF(AIN(J+3)-ABS(V1(J)))395,253,253
  253 CONTINUE
      GO TO 277
C     ***** SEE IF WITHIN SPHERE *****
  255 DSQ=VMV(X,AA,X)
      IF(DMX-DSQ)395,256,256
  256 IF(DSQ-.0001)258,260,260
  258 IF(KFUN-402)395,260,260
  260 TEM=SQRT(DSQ)
      IF(AIN(8))   265,265,261
C     ***** SELECT ONLY FIRST ASYMMETRIC UNIT ENCOUNTERED *****
  261 IF(LATM)    265,265,262
  262 ZMIN=FLOAT(I)*100000.
      ZMAX=ZMIN+100000.
      DO 264 J=1,LATM
      ZSTO=ATOMS(1,J)
      IF(ZSTO-ZMIN)   264,263,263
  263 IF(ZMAX-ZSTO)   264,264,395
  264 CONTINUE
C     ***** SELECT VECTORS ACCORDING TO CODES IF ANY *****
  265 IF(NCD)   277,277,268
  268 DO 275 J=1,NCD
  269 IF(ITOM-KD(1,J))275,270,270
  270 IF(KD(2,J)-ITOM)275,271,271
  271 IF(I-KD(3,J))   275,272,272
  272 IF(KD(4,J)-I)   275,273,273
  273 IF(TEM-CD(1,J)) 275,274,274
  274 IF(CD(2,J)-TEM) 275,277,277
  275 CONTINUE
      GO TO 395
  277 V1(1) = 100000.*FLOAT(I)+FLOAT((1110-L*100-M*10-NN)*100+K)
      IF(KFUN-402)278,325,325
C     ***** DETERMINE CORRECT POSITION IN SORTED VECTOR TABLE *****
  278 IF(NUM)317,317,279
  279 DO 315 II=1,NUM
      TT=S(2,II)-TEM
      IF(ABS(TT)-0.0001)297,297,281
  281 IF(TT)315,297,283
C     ***** MOVE LONGER VECTORS TOWARD END OF TABLE *****
  283 IF(200-NUM)287,287,289
  287 NUM=199
  289 IJ=NUM
      DO 295 J=II,NUM
      S(1,IJ+1)=S(1,IJ)
      S(2,IJ+1)=S(2,IJ)
  295 IJ=IJ-1
      GO TO 319
C     ***** CHECK FOR DUPLICATE VECTORS IF DISTANCES ARE EQUAL *****
  297 CALL ATOM(S(1,II),Z)
      DO 305 J=1,3
      IF(ABS(X(J)+Y(J)-Z(J))-0.0001)305,305,315
  305 CONTINUE
      GO TO 395
  315 CONTINUE
      IF(200-NUM)320,320,317
C     ***** STORE THE RESULT IN VECTOR TABLE *****
  317 II=NUM+1
  319 NUM=NUM+1
      S(1,II)=V1(1)
      S(2,II)=TEM
  320 IF(KFUN-106)395,325,325
C     ***** STORE RESULT IN ATOMS TABLE *****
  325 DO 330 J=1,3
  330 V1(J+1)=X(J)+Y(J)
      CALL STOR
  395 CONTINUE
  400 CONTINUE
C     ***** PRINT OUT DISTANCES *****
  421 FORMAT(1H0,10X,20HVECTORS FROM ATOM  (,I3,1H,,I5,1H),6X,8HTO ATOMS
     &,I4,8H THROUGH,I4)
      I0=AMOD(T1,100000.0)
      WRITE (NOUT,421)ITOM,I0,ITAR1,ITAR2
      IF(NNJ2.GT.0) THEN
      WRITE(NOUT,710)
  710 FORMAT(11X,'DELTA MSD = DIFFERENCE MEAN-SQUARE DISPLACEMENT IN BON
     &D DIRECTION = PROJ(2) - PROJ(1)'/)
      ENDIF
      IF(NUM)500,500,423
  423 DO 435 I=1,NUM
      T2=S(1,I)
      I1=T2/100000.
      I2=T2-FLOAT(I1)*100000.
      CALL ATOM(T2,Z)
      IF(I-1)432,432,434
  427 FORMAT(1H ,13X,2(A6,1X),39X,1H(,I3,1H,,I5,1H),3F7.4,7X,3HD =,F6.3)
  429 FORMAT(1H ,13X,2(A6,1X),2(3H  (,I3,1H,,I5,1H),3F7.4,3X),4X,3HD =,F
     &6.3)
  432 WRITE (NOUT,429)CHEM(ITOM),CHEM(I1),ITOM,I0,(Y(J),J=1,3
     1),I1,I2,(Z(J),J=1,3),S(2,I)
      GOTO 433
  434 WRITE (NOUT,427)CHEM(ITOM),CHEM(I1),I1,I2,(Z(J),J=1,3),
     1S(2,I)
  433 IF(NNJ2.EQ.0) GOTO 435
C     U1 REPRESENTS THE SYMMETRY CODE OF ATOM 1 (ADC)
      U1=T1
C     DZ(J) = BOND VECTOR
      DO 702 J=1,3
      DZ(J)=Z(J)-Y(J)
  702 CONTINUE
C     FIRST TRANSFER BOND VECTOR TO CARTESIAN SYSTEM
      CALL VM(DZ,AAREV,VAUTR)
      DO 703 K=1,2
C     SUBROUTINE PAXES CALCULATES THE TENSOR OF THERMAL VIBRATION
C     Q(3,3) WITH REGARD TO CARTESIAN AXES
      CALL PAXES(U1,-3)
      TRACE=Q(1,1)+Q(2,2)+Q(3,3)
C     VO'*Q*VO/D**2 GIVES MEAN SQUARE DISPLACEMENT IN BOND DIRECTION
      PROJ(K) = VMV(VAUTR,Q,VAUTR)/S(2,I)**2
      ALPHA(K)= TRACE-PROJ(K)
      U1=T2
  703 CONTINUE
C     QUANTITY DIFF FOR RIGID BOND TEST
      DIFF = PROJ(2)-PROJ(1)
C     BOND LENGTH CORRECTIONS
      SUMME= ALPHA(1)+ALPHA(2)
      PROD= 2*SQRT(ALPHA(1)*ALPHA(2))
      DIV = 2*S(2,I)
C     UPPER LIMIT
      DUPPER = S(2,I) + (SUMME + PROD)/DIV
C     INDEPENDENT MOTION
      DINDEP = S(2,I) + SUMME/DIV
C     RIDING ATOM
      DRIDIN = 0.0
      DELTA = ALPHA(2) - ALPHA(1)
      IF(DELTA) 705,704,704
  704 DRIDIN = S(2,I) + DELTA/DIV
C     LOWER LIMIT
  705 DLOWER = S(2,I) + (SUMME-PROD)/DIV
      WRITE(NOUT,706) DIFF,PROJ(2),PROJ(1),ALPHA(2),ALPHA(1),
     1 DUPPER,DINDEP,DRIDIN,DLOWER
  706 FORMAT(30X,11HDELTA MSD :,F8.5,3X,9HPROJ(2) :,F8.5,3X,9HPROJ(1) :,
     &F8.5,/30X,'CORRECTED BOND LENGTH',10X,6HBETA :,F7.4,3X,7HALPHA :,F
     &7.4/30X,13HUPPER LIMIT :,F5.3,3X,20HINDEPENDENT MOTION :,F5.3,3X,1
     &4HRIDING MODEL :,F5.3,3X,13HLOWER LIMIT :,F5.3)
  435 CONTINUE
C     ***** CALCULATE ANGLES ABOUT REF ATOM IF CODE IS 102 *****
  437 IF(KFUN-102)500,451,500
  441 FORMAT(1H0,10X,18HANGLES AROUND ATOM,I5)
  451 WRITE (NOUT,441)ITOM
      L=NUM-1
      IF(L)500,500,457
  457 DO 465 I=1,L
      T2=S(1,I)
      T3=S(2,I)
      I1=T2/100000.
      I2=T2-FLOAT(I1)*100000.
      CALL ATOM(T2,X)
      CALL DIFV(X,Y,U)
      CALL MV(AA,U,V2)
      M=I+1
      DO 465 J=M,NUM
      T4=S(1,J)
      J1=T4/100000.
      J2=T4-FLOAT(J1)*100000.
      CALL ATOM(T4,Z)
      CALL DIFV(Z,Y,V)
      F=ARCCOS(VV(V,V2)/(T3*S(2,J)))
      CALL DIFV(X,Z,V3)
      F1=SQRT(VMV(V3,AA,V3))
  460 FORMAT(1H ,13X,3(A6,1X),7X,3(2H (,I3,1H,,I5,1H)),12X,3HD =,F6.3,7X
     &,3HA =,F6.2)
  465 WRITE (NOUT,460)CHEM(I1),CHEM(ITOM),CHEM(J1),I1,I2,ITOM
     1,I0,J1,J2,F1,F
  495 CONTINUE
  500 CONTINUE
      IF(LAST-LIST)505,505,178
  505 IF(KFUN2-6)600,176,600
  600 IF(KFUN-106)610,605,610
  605 LATM=LATOM
  610 RETURN
      END
